#include <stdbool.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>
#include <time.h>

struct ret_t {
  int low;
  int mid;
};

typedef struct ret_t ret;

static ret* partition(int* tab, int low, int high) {
    // Partitionnement 3-way
    int ref = high--;
    int mid = low;
    while (mid <= high) {
        if (tab[mid] < tab[ref]) {
            int tmp   = tab[low];
            tab[low] = tab[mid];
            tab[mid]  = tmp;
            low++;
            mid++;
        }
        else if (tab[mid] == tab[ref]) {
            mid++;
        }
        else {
            int tmp   = tab[high];
            tab[high] = tab[mid];
            tab[mid]  = tmp;
            high--;
        }
    }

    int tmp  = tab[ref];
    tab[ref] = tab[mid];
    tab[mid] = tmp;

    ret* r = malloc(sizeof(*r));
    r->low = low;
    r->mid = mid;

    return r;
}

static void quicksort(int* tab, int low, int high) {
    if (low < high) {
        ret* data = partition(tab, low, high);
        quicksort(tab, low, data->low - 1); // Trier partie < ref
        quicksort(tab, data->mid, high);    // Trier partie > ref
                                            // Ignorer partie == ref

        free(data);
    }
}

int main() {
    const int N = 500000;
    clock_t t1, t2;

    float moy[10];

    for (int j = 0; j < 10; j++) {
        srand(j);
        int a[N];

        for (int i = 0; i < N; i++)
            a[i] = rand() % 1000;

        /* Decommenter ce code et commenter la boucle prcdente pour un 
         * tableau dj tri en entre de la fonction */
        /*for (int i = 0; i < N; i++) {
            a[i] = i+1;
        }*/

        
        t1 = clock();
        quicksort(a, 0, N-1);
        t2 = clock();
        moy[j] = (float) (t2 - t1)/CLOCKS_PER_SEC;
        printf("%d: It tooks: %f\n", j, moy[j]);
    }

    float moyenne = 0;

    for (int i = 0; i < 10; moyenne += moy[i++]);
    printf("Moyenne: %f\n", moyenne / 10);

    return 0;
}